<?php
/******************************************************************************
* shoutdb.php	                                                              *
*******************************************************************************
* SMF: Simple Machines Forum - Ultimate Shoutbox MOD                          *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           1.35	                                      *
* Software originally by:     Greg Haase				      *
* Ported to SMF by:	      Matthew Wolf (a.k.a Grudge)    		      *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}shoutbox
  	(ID_SHOUT int(11) NOT NULL auto_increment, 
  	ID_MEMBER int(11) NOT NULL,
  	displayname tinytext default NULL,
    	message text NOT NULL,
    	email tinytext default NULL,
    	time int(11) NOT NULL,
    	PRIMARY KEY  (ID_SHOUT)) TYPE=MyISAM", __FILE__, __LINE__);

// Determine whether an PM upgrade is necessary.
$request = db_query("
	SHOW COLUMNS
	FROM {$db_prefix}shoutbox
	LIKE 'id'", __FILE__, __LINE__);
$need_upgrade = mysql_num_rows($request) > 0;
if ($need_upgrade)
{
	// Backup old table... shamelessly stolen from upgrade script.
	$result = db_query("
		SHOW CREATE TABLE {$db_prefix}shoutbox", __FILE__, __LINE__);
	list (, $create) = mysql_fetch_row($result);
	$create = preg_split('/[\n\r]/', $create);
	foreach ($create as $k => $l)
	{
		if (strpos($l, 'KEY') === false)
			unset($create[$k]);
	}
	db_query("
		DROP TABLE IF EXISTS `backup_shoutbox`", __FILE__, __LINE__);
			
	db_query("
		CREATE TABLE `backup_shoutbox`" . (!empty($create) ? ' (
					' . implode('
					', $create) . ')' : '') . "
		TYPE=MyISAM
		SELECT * FROM {$db_prefix}shoutbox", __FILE__, __LINE__);
	
	// Alter the old table.
	db_query("ALTER TABLE {$db_prefix}shoutbox
		DROP PRIMARY KEY,
		CHANGE COLUMN id ID_SHOUT int(11) unsigned NOT NULL auto_increment,
		DROP name", __FILE__, __LINE__);
	db_query("ALTER TABLE {$db_prefix}shoutbox
		ADD PRIMARY KEY (ID_SHOUT)", __FILE__, __LINE__);

}
$toSet = array();
$toSet['shoutdir'] = '0';
$toSet['shoutlimit'] = '10';
$toSet['shoutmaxchr'] = '30';
$toSet['shoutsplitchr'] = '27';
$toSet['enablescrollshout'] = '1';
$toSet['shoutscrollwidth'] = '150';
$toSet['shoutscrollheight'] = '200';
$toSet['shoutscrollspeed'] = '2';
$toSet['shoutscrolldir'] = 'up';
$toSet['shoutscrolldelay'] = '60';
$toSet['shoutsep'] = '<hr />';
$toSet['enablearchiveshout'] = '1';
$toSet['shout_noGuestEmail'] = '0';
$toSet['shout_upgrade_121'] = '1';
$toSet['shout_enableXML'] = '0';

// Insert settings
foreach ($toSet as $key => $value){
	db_query("INSERT IGNORE INTO
		{$db_prefix}settings
		(`variable`, `value`)
		VALUES ('$key', '$value')", __FILE__, __LINE__);
}

// Permissions
if (empty($modSettings['shout_upgrade_121']))
db_query("
	INSERT INTO {$db_prefix}permissions
		(ID_GROUP, permission)
	VALUES
		(0, 'make_shout'),
		(2, 'make_shout'),
		(2, 'delete_shout')", __FILE__, __LINE__);
		
		
?>