<id>
Ultimate Shoutbox
</id>

<version>
1.36o
</version>

<mod info>
This is your basic shoutbox.  Your registers users type in a message and click shout.  Guests on your
site (if you give them access to the block) will type in their name, email address and message before
clicking shout.

The format of each 'shout' is Date, Name, Message.  If a registered user posts a shout, their name
becomes a link to their profile.  If a guest posts a shout, their name is a mailto: to the email
address they entered.

For administrators, there is also a delete button next to each individual shout.

Instructions:
1. Upload shoutdb.php into your board directory and run it (be sure to delete it afterwards).
2. Install from this mod file manually or using boardmod
3. Upload shout.php into your sources dir.
4. Upload deleteshout.gif to your $themedir/images directory
5. Anywhere in your template call the function smfshout() to show the shoutbox
6. Go into the Feature Settings page and choose the appropriate settings
7. Type in a message and click Shout!

For peopleupgrading from YABB SE:
The shoutdb.php script will give you the option of porting your shouts from YABB SE accross to SMF. Your settings should have been brought over with the SMF upgrade script. If for some reason this is not the case you will need to choose "upgrade" and then run the script again and choose "new". This will port your old shouts accross and reset the settings to the default values. The upgrade script duplicates your existing shoutbox table and upon completition will leave the old table untouched. If you are happy that the upgrade was successful you can delete the old table manually.

Author:
The ultimate shoutbox was originally written by Greg Haase. This SMF version was ported by Matthew Wolf (a.k.a Grudge). Please direct any questions regarding this version to Grudge, either by email (me@mattwolf.co.uk) or by posting in the appropriate place at www.simplemachines.og (the preferred option!)

History:

Version 1.36:
1. Call the shoutbox form from the shoutbox template.
2. Fixed session checks on delete.
3. Verify guest names aren't already in use.

Version 1.31:
1. Added an option to turn on XML refresh.

Version 1.3:
1. Added an automatic XML refresh for browsers which support it.
2. Added an option to not require email address for guests.

Version 1.1:
1. Updated to Beta 6
2. The shoutbox now uses templates! You can edit the template much easier using the template file.
3. Several bug fixes including formatting time.

Version 1.03:
1. Updated to beta 5.1 public

Version 1.02:
1. Updated to beta 5.0
2. Fixed bug in db script that causes an error message.
3. ixed bug when deleting all shouts if you didn't have any.

Version 1.0:
1. Ported to SMF
2. Reformated shout.php to be much cleaner
3. Included upgrade script 

YABBSE History:
Version 1.3:
1. Fixed this boardmod file
2. added SSI
3. Fixed shout validation
4. Fixed shout redirect for folders other than $boarddir


Version 1.2:
1. Added Shout Archive Page and Link (original concept by OldiesDann from the
   YaBB SE Community)
2. Added Several flavors of delete option for admins
3. Admin can turn on or turn off shouting from the archive page
4. Added "Shout Separator" option.  The old version used <hr> as the separator,
   Now you can enter anything: e.g. put a | if your shouts to scroll horizontally.
5. Removed a lot of temp variables, did some general clean-up. (Courtesy of
   [unknown] from the YaBB SE Community)
6. Input boxes clear on focus (Courtesy of GauGau from the YaBB SE Community)
7. Shout Time now stored and retrieved as standard per YaBB SE
8. Integrated with english.lng in case someone wants to do a translation

Version 1.1:
1. Security Fix: HTML or PHP tags entered by user no longer crash the shoutbox.
2. embedded links now work
3. now call shoutbox by <yabb shout> tag

version 1.0:
1. Chiani's Magic Make Long Words Short Words Recipe
2. Josh Darnell's Famous ShoutBox Marquee Add-on
3. Now sporting the following permissions options:
	members only
	admins only
	everyone
4. Fully Integrated Control Panel in the Intalled Mods page.

version 0.2:
1. Delete function doublechecks that you are an administrator before proceeding
2. Smilies activated
3. YaBBC functions work
(note: smilies and YaBBC functions must be entered manually, there are no buttons for them)
4. Ability to modify number of shouts returned
5. Select whether you want the shouts to be decending or ascending
6. Censor activated


version 0.1:
Original Version

************ some background info ***************************************************************************
A word about temporary tables.  Shout.php uses a temporary table to call shouts, but ony when calling
shouts in Ascending order.  In order to call the most recent shouts from your database, the shouts must be
called in Descending order (otherwise you will always only get the first shouts that were entered up to
your limit, and never get the most recent shouts).  The temp table that is generated is unique to the user,
so there is no need to were about multiple users refreshing the page at the same time.  The table is dropped
as soon as the shouts are retrieved.  There was some concern that use of the temporary table would cause too
much overhead.  I conducted a test with ten identical shouts using without using the temp table and ten shouts
using the temp table.  On average, use of the temp table increases your page load time by 0.004 (4 thousandths)
of a second. Given such a narrow margin, I believe that you would need to experience more than 1000 clicks a
minute before experiencing any performace problems.
*************************************************************************************************************

</mod info>

<author>
Greg Haase / Matthew Wolf
</author>

<homepage>
http://www.mymods.co.uk
</homepage>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		'collapse' => array('Subs-Boards.php', 'CollapseCategory'),
</search for>

<add after>
		'delete_all_shouts' => array('shout.php', 'delete_all_shouts'),
		'delete_shout_age' => array('shout.php', 'delete_shout_age'),
		'delete_shout' => array('shout.php', 'delete_shout'),
</add after>

<search for>
		'sendtopic' => array('SendTopic.php', 'SendTopic'),
</search for>

<add after>
		'shout' => array('shout.php', 'Shout'),
		'shout_archive' => array('shout.php', 'ShoutArchive'),
		'shout_xml' => array('shout.php', 'shout_display'),
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
		log_error('Copyright removed!!');
	}
}
</search for>

<add after>
function smfshout()
{
	global $sourcedir;

	include_once("$sourcedir/shout.php");
	shout_display(true);
}

</add after>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('text', 'karmaSmiteLabel'),
</search for>

<add after>
		array('heading', &$txt['shoutbox_0']),
			array('check', 'shout_enableXML'),
			array('text', 'shoutlimit'),
			array('text', 'shoutsep'),
			array('text', 'shoutmaxchr'),
			array('text', 'shoutsplitchr'),
			array('check', 'shout_noGuestEmail'),
			array('select', 'shoutdir', array(
				'1' => &$txt['shoutbox_19'],
				'0' => &$txt['shoutbox_20'],
			)),
			array('check', 'enablearchiveshout'),
			array('check', 'enablescrollshout'),
			array('text', 'shoutscrollwidth'),
			array('text', 'shoutscrollheight'),
			array('text', 'shoutscrolldelay'),
			array('select', 'shoutscrolldir', array(
				'up' => &$txt['shoutbox_37'],
				'down' => &$txt['shoutbox_38'],
				'left' => &$txt['shoutbox_39'],
				'right' => &$txt['shoutbox_40'],
			)),
			array('select', 'shoutscrollspeed', array(
				'1' => &$txt['shoutbox_31'],
				'2' => &$txt['shoutbox_32'],
				'3' => &$txt['shoutbox_33'],
				'4' => &$txt['shoutbox_34'],
				'5' => &$txt['shoutbox_35'],
			)),
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
//text for Ultimate Shoutbox
$txt['shoutbox_0'] = 'Shoutbox';
$txt['shoutbox_1'] = 'Shoutbox Archive';
$txt['shoutbox_2'] = 'Delete shouts older than:';
$txt['shoutbox_3'] = 'days';
$txt['shoutbox_4'] = 'Delete all shouts over your current limit of';
$txt['shoutbox_5'] = 'Delete';
$txt['shoutbox_6'] = 'Name';
$txt['shoutbox_7'] = 'Email';
$txt['shoutbox_8'] = 'Message';
$txt['shoutbox_9'] = 'Shout';
$txt['shoutbox_10'] = 'Sorry, if you are a guest you must enter both your name and your email address';
$txt['shoutbox_11'] = 'Whoops, looks like you forgot to fill in one of the Shoutbox fields.  Please try again.';
$txt['shoutbox_12'] = 'Sorry, if you are a guest you must enter a valid email address when using the Shoutbox.';
$txt['shoutbox_13'] = 'Sorry, but you do not have the proper priveledges to delete that.';
$txt['shoutdir'] = 'Shout Direction';
$txt['shoutbox_19'] = 'Ascending';
$txt['shoutbox_20'] = 'Descending';
$txt['shoutsep'] = 'Shout Separator';
$txt['enablearchiveshout'] = 'Allow people to shout from the archive page?';
$txt['shoutlimit'] = 'Number of shouts to return';
$txt['shoutmaxchr'] = 'Max number of characters per line';
$txt['shoutsplitchr'] = 'Character number to split long words at (usually 3 less than max)';
$txt['enablescrollshout'] = 'Enable scrolling';
$txt['shoutbox_27'] = 'The following options are only available is scrolling is activated:';
$txt['shoutscrollwidth'] = 'Scroll box width (pixels)';
$txt['shoutscrollheight'] = 'Scroll box height (pixels)';
$txt['shoutscrollspeed'] = 'Scrolling speed';
$txt['shout_noGuestEmail'] = 'Don\'t require email address for guests';
$txt['shout_enableXML'] = 'Enable javascript XML refreshing of the shoutbox. (This will increase server load)';
$helptxt['shout_enableXML'] = 'Turning on this option will make the shoutbox refresh automatically every five seconds - but will increase the server load considerably.';
$txt['shoutbox_31'] = 'slowest';
$txt['shoutbox_32'] = 'slower';
$txt['shoutbox_33'] = 'medium';
$txt['shoutbox_34'] = 'faster';
$txt['shoutbox_35'] = 'fastest';
$txt['shoutscrolldir'] = 'Scrolling direction';
$txt['shoutbox_37'] = 'up';
$txt['shoutbox_38'] = 'down';
$txt['shoutbox_39'] = 'left';
$txt['shoutbox_40'] = 'right';
$txt['shoutscrolldelay'] = 'Scroll Delay (milliseconds - normal is 60)';
$txt['shoutbox_42'] = 'Delete Options';
$txt['shoutbox_43'] = 'View All';
$txt['permissiongroup_shout'] = 'Shoutbox';
$txt['permissionname_make_shout'] = 'Can Shout';
$txt['permissionname_delete_shout'] = 'Can Delete Shouts';
$txt['shout_delete_selected'] = 'Delete Selected';
$txt['cannot_delete_shout'] = 'You do not have permission to delete shouts.';
$txt['cannot_make_shout'] = 'You do not have permission to shout.';
</add before>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
?>
</search for>

<add before>
function ssi_shout($showform = true)
{
	global $sourcedir;

	include_once("$sourcedir/shout.php");
	shout_display($showform);
}
</add before>

<edit file>
$boarddir/ssi_examples.php
</edit file>

<search for>
		<hr />

			<h3>Some notes on usage</h3>
</search for>

<add before>
			<h3>Shoutbox: &lt;?php ssi_shout(); ?&gt;</h3>
			<?php ssi_shout(); ?>

		<hr />
</add before>

<edit file>
$boarddir/ssi_examples.shtml
</edit file>

<search for>
			<h3>Recent Calendar Events Function: &lt;!--#include virtual="./SSI.php?ssi_function=recentEvents" --&gt;</h3>
			<!--#include virtual="./SSI.php?ssi_function=recentEvents" -->

		<hr />
</search for>

<add after>
			<h3>Shoutbox Function: &lt;!--#include virtual="./SSI.php?ssi_function=shout" --&gt;</h3>
			<!--#include virtual="./SSI.php?ssi_function=shout" -->

		<hr />
</add after>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
			'pm' => array(
				'pm_read' => false,
				'pm_send' => false,
			),
</search for>

<add after>
			'shout' => array(
				'make_shout' => false,
				'delete_shout' => false,
			),
</add after>